<!DOCTYPE html>
<html lang="en">
<head>
     <meta charset="UTF-8">
     <meta http-equiv="X-UA-Compatible" content="IE=edge">
     <meta name="viewport" content="width=device-width, initial-scale=1.0">
     <title>Task 45.40</title>

     <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
     <!-- Font Awesome Icons -->
     <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
     <!-- Theme style -->
     <link rel="stylesheet" href="dist/css/adminlte.min.css">
     <!-- Import them style bootstrap cho datatable -->
     <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
     <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>
<body class="hold-transition sidebar-mini">
     <div class="wrapper">
          <!-- Navbar -->
          <nav class="main-header navbar navbar-expand navbar-white navbar-light">
              <!-- Left navbar links -->
              <ul class="navbar-nav">
                  <li class="nav-item">
                      <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                  </li>
                  <li class="nav-item d-none d-sm-inline-block">
                      <a href="index3.html" class="nav-link">CRUD</a>
                  </li>
              </ul>
              <!-- Right navbar links -->
              <ul class="navbar-nav ml-auto">
                  <!-- Notifications Dropdown Menu -->
                  <li class="nav-item">
                      <a class="nav-link" data-widget="fullscreen" href="#" role="button">
                          <i class="fas fa-expand-arrows-alt"></i>
                      </a>
                  </li>
              </ul>
          </nav>
          <!-- /.navbar -->
          <!-- Main Sidebar Container -->
          <aside class="main-sidebar sidebar-dark-primary elevation-4">
              <!-- Brand Logo -->
              <a href="" class="brand-link">
                  <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
                      style="opacity: .8">
                  <span class="brand-text font-weight-light">Devcamp</span>
              </a>
  
              <!-- Sidebar -->
              <div class="sidebar">
                  <!-- Sidebar user panel (optional) -->
                  <div class="user-panel mt-3 pb-3 mb-3 d-flex">
                      <div class="image">
                          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
                      </div>
                      <div class="info">
                          <a href="#" class="d-block">Devcamp</a>
                      </div>
                  </div>
  
                  <!-- SidebarSearch Form -->
                  <div class="form-inline">
                      <div class="input-group" data-widget="sidebar-search">
                          <input class="form-control form-control-sidebar" type="search" placeholder="Search"
                              aria-label="Search">
                          <div class="input-group-append">
                              <button class="btn btn-sidebar">
                                  <i class="fas fa-search fa-fw"></i>
                              </button>
                          </div>
                      </div>
                  </div>
  
                  <!-- Sidebar Menu -->
                  <nav class="mt-2">
                      <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                          data-accordion="false">
                          <!-- Add icons to the links using the .nav-icon class
                 with font-awesome or any other icon font library -->
                          <li class="nav-item menu-open">
                              <a href="#" class="nav-link active">
                                  <i class="nav-icon fas fa-tachometer-alt"></i>
                                  <p>
                                      UserList Pages
                                      <i class="right fas fa-angle-left"></i>
                                  </p>
                              </a>
                              <ul class="nav nav-treeview">
                                  <li class="nav-item">
                                      <a href="#" class="nav-link ">
                                          <i class="far fa-circle nav-icon"></i>
                                          <p>Active Page</p>
                                      </a>
                                  </li>
                                  <li class="nav-item">
                                      <a href="#" class="nav-link">
                                          <i class="far fa-circle nav-icon"></i>
                                          <p>Inactive Page</p>
                                      </a>
                                  </li>
                              </ul>
                          </li>
                          <li class="nav-item">
                              <a href="#" class="nav-link">
                                  <i class="nav-icon fas fa-th"></i>
                                  <p>
                                      Simple Link
                                      <span class="right badge badge-danger">New</span>
                                  </p>
                              </a>
                          </li>
                      </ul>
                  </nav>
                  <!-- /.sidebar-menu -->
              </div>
              <!-- /.sidebar -->
          </aside>
          <!-- Content Wrapper. Contains page content -->
          <div class="content-wrapper">
              <!-- Content Header (Page header) -->
              <div class="content-header">
                  <div class="container-fluid">
                      <div class="row mb-2">
                          <div class="col-sm-6">
                              <h1 class="m-0">Dashboard V2</h1>
                          </div><!-- /.col -->
                          <div class="col-sm-6">
                              <ol class="breadcrumb float-sm-right">
                                  <li class="breadcrumb-item"><a href="#">Home</a></li>
                                  <li class="breadcrumb-item active">Starter Page</li>
                              </ol>
                          </div><!-- /.col -->
                      </div><!-- /.row -->
                  </div><!-- /.container-fluid -->
              </div>
              <!-- /.content-header -->
  
              <!-- Main content -->
              <div class="content">
                  <div class="container-fluid">
                      <div class="text-center">
                          <h2>F120 - Quản trị Users</h2>
                      </div>
                      <div class="form-group">
                          <button class="btn btn-success" id="btn-add-user"><i class="fa fa-plus"></i>&nbsp; New
                              voucher</button>
                      </div>
                  </div>
                  <!-- Vouche Data Table -->
                  <div class="container">
                      <table class="table table-bordered table-striped table-hover" id="user-table">
                          <thead>
                              <tr>
                                   <th>Id</th>
                                   <th>Firsname</th>
                                   <th>Lastname</th>
                                   <th>Country</th>
                                   <th>Subject</th>
                                   <th>Customer Type</th>
                                   <th>Register Status</th>
                                   <th>Action</th>
                              </tr>
                          </thead>
                      </table>
                  </div>
  
                  <!-- Vùng Modal -->
  
                  <!-- Create voucher modal -->
                  <div>
                      <div id="create-voucher-modal" class="modal fade" tabindex="-1">
                          <div class="modal-dialog">
                              <div class="modal-content">
                                  <div class="modal-header">
                                      <h5 class="modal-title" id="h5-modal-title">Create new voucher</h5>
                                      <button class="close" data-dismiss="modal">&times;</button>
                                  </div>
                                  <div class="modal-body">
                                      <form>
                                          <div class="row form-group">
                                              <div class="col-sm-4">
                                                  <label for="input-create-voucher-code">Voucher code</label>
                                              </div>
                                              <div class="col-sm-8">
                                                  <input type="text" id="input-create-voucher-code" name="vouchercodes"
                                                      placeholder="Voucher code" class="form-control">
                                              </div>
                                          </div>
                                          <div class="row form-group">
                                              <div class="col-sm-4">
                                                  <label for="input-create-discount">Discount</label>
                                              </div>
                                              <div class="col-sm-8">
                                                  <input type="number" id="input-create-discount" name="discount"
                                                      placeholder="Discount" class="form-control">
                                              </div>
                                          </div>
                                      </form>
                                  </div>
                                  <div class="modal-footer">
                                      <button class="btn btn-secondary" id="btn-create-cancel"
                                          data-dismiss="modal">Cancel</button>
                                      <button class="btn btn-primary" id="btn-create-voucher">Create Voucher</button>
                                  </div>
                              </div>
                          </div>
                      </div>
                  </div>
  
                  <!-- Update voucher modal -->
                  <div>
                      <div id="update-voucher-modal" class="modal fade" tabindex="-1">
                          <div class="modal-dialog">
                              <div class="modal-content">
                                  <div class="modal-header">
                                      <h5 class="modal-title" id="h5-modal-title">Update a Voucher</h5>
                                      <button class="close" data-dismiss="modal">&times;</button>
                                  </div>
                                  <div class="modal-body">
                                      <form>
                                          <div class="row form-group">
                                              <div class="col-sm-4">
                                                  <label for="input-update-voucher-code">Voucher code</label>
                                              </div>
                                              <div class="col-sm-8">
                                                  <input type="text" id="input-update-voucher-code" name="vouchercodes"
                                                      placeholder="Voucher code" class="form-control">
                                              </div>
                                          </div>
                                          <div class="row form-group">
                                              <div class="col-sm-4">
                                                  <label for="input-update-discount">Discount</label>
                                              </div>
                                              <div class="col-sm-8">
                                                  <input type="number" id="input-update-discount" name="discount"
                                                      placeholder="Discount" class="form-control">
                                              </div>
                                          </div>
                                      </form>
                                  </div>
                                  <div class="modal-footer">
                                      <button class="btn btn-secondary" id="btn-update-cancel"
                                          data-dismiss="modal">Cancel</button>
                                      <button class="btn btn-primary" id="btn-update-voucher">Update Voucher</button>
                                  </div>
                              </div>
                          </div>
                      </div>
                  </div>
  
                  <!-- Delete confirm modal -->
                  <div>
                      <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
                          <div class="modal-dialog">
                              <div class="modal-content">
                                  <div class="modal-header">
                                      <h5 class="modal-title" id="h5-modal-title">Voucher Delete Confirmation</h5>
                                      <button class="close" data-dismiss="modal">&times;</button>
                                  </div>
                                  <div class="modal-body">
                                      <label>Bạn có chắc chắn muốn xóa voucher này không?</label>
                                  </div>
                                  <div class="modal-footer">
                                      <button class="btn btn-danger" id="btn-confirm-delete-voucher">Confirm</button>
                                      <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                                  </div>
                              </div>
                          </div>
                      </div>
                  </div>
              </div><!-- /.container-fluid -->
          </div>
          <!-- /.content -->
      </div>
      <!-- /.content-wrapper -->
  
      <!-- Control Sidebar -->
      <aside class="control-sidebar control-sidebar-dark">
          <!-- Control sidebar content goes here -->
          <div class="p-3">
              <h5>Title</h5>
              <p>Sidebar content</p>
          </div>
      </aside>
      <!-- /.control-sidebar -->
      <!-- Main Footer -->
      <footer class="main-footer">
          <!-- To the right -->
          <div class="float-right d-none d-sm-inline">
              Anything you want
          </div>
          <!-- Default to the left -->
          <strong>Copyright &copy; 2023 <a href="https://adminlte.io">Devcamp</a>.</strong> All rights
          reserved.
      </footer>
      </div>
     <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>
</body>
<script>
     "use strict";
     /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
     const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";

     //biến toàn cục để lưu trữ id user đang được update hoặc delete. Mặc định = 0;
     var gUserId = 0;

     //biến mảng hằng số chứa danh sách tên các thuộc tính 
     const gUSER_COLS = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];

     //biến mảng toàn cục định nghĩa chỉ số các cột trong mảng 
     const gUSER_ID_COL = 0;
     const gFIRST_NAME_COL = 1;
     const gLAST_NAME_COL = 2;
     const gCOUNTRY_COL = 3;
     const gSUBJECT_COL = 4;
     const gCUSTOMER_TYPE_COL = 5;
     const gREGISTER_STATUS_COL = 6;
     const gACTION_COL = 7;

     //khai báo datatable &mapping comlumns
     var gUserTable = $("#user-table").DataTable({
          columns:[
               {data: gUSER_COLS[gUSER_ID_COL]},
               {data: gUSER_COLS[gFIRST_NAME_COL]},
               {data: gUSER_COLS[gLAST_NAME_COL]},
               {data: gUSER_COLS[gCOUNTRY_COL]},
               {data: gUSER_COLS[gSUBJECT_COL]},
               {data: gUSER_COLS[gCUSTOMER_TYPE_COL]},
               {data: gUSER_COLS[gREGISTER_STATUS_COL]},
               {data: gUSER_COLS[gACTION_COL]},
          ], 
          columnDefs:[
               {
                     //định nghĩa lại cột action
                    targets: gACTION_COL,
                    defaultContent:`
                    <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                    <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                    `
               }  
          ]
     });

     /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
     $(document).ready(function(){
          onPageLoading();
     });

     //Gán sự kiện update - sửa 1 user
     $("#user-table").on("click", ".edit-user", function(){
          onBtnEditUserClick(this);
     });

     //Gán sự kiện Delete - xóa 1 user
     $("#user-table").on("click", ".delete-user", function(){
          onBtnDeleteUserClick(this);
     });
     /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
     //hàm xử lý việc tải trang 
     function onPageLoading(){
          //load dữ liệu lên datatable
          getAllUser();
     }

     //hàm xử lý sự kiện khi icon edit được nhấn 
     function onBtnEditUserClick(paramEdit){
          //lưu thông tin user id đang được edit vào biến toàn cục 
          gUserId = getUserIdFromButton(paramEdit);
          console.log("UPDATE, Id của user tương ứng là: " + gUserId); 
     }

      //hàm xử lý sự kiện khi icon edit được nhấn 
      function onBtnDeleteUserClick(paramDelete){
          //lưu thông tin user id đang được edit vào biến toàn cục 
          gUserId = getUserIdFromButton(paramDelete);
          console.log("DELETE, Id của user tương ứng là: " + gUserId); 
     }
     /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
     // hàm gọi api để load dữ liệu lên bảng 
     function getAllUser(){
          $.ajax({
               url: gBASE_URL,
               type: "GET", 
               success: function(paramUser){
                    console.log(paramUser);
                    loadDataToUserTable(paramUser);
               },
               error: function(ajaxContent){
                    alert(ajaxContent.responseText);
               }
          });
     }

     //hàm load dữ liệu user lên bảng 
     function loadDataToUserTable(paramUser){
          gUserTable.clear();
          gUserTable.rows.add(paramUser);
          gUserTable.draw();
     }

     //hàm dựa vào button detail (edit or delete) xác định được id user
     function getUserIdFromButton(paramButton){
          var vTableRow = $(paramButton).parents("tr");
          var vUserRowData = gUserTable.row(vTableRow).data();
          return vUserRowData.id;
     }
</script>
</html>